*!Ŀ
*!                     NG KHAI DEVELOPMENT CORP.                       
*!             Computer Consultancy * Software Development             
*! 				              Import * Export                       
*!               FAX : 63-32-86241       73751.1012@Compuserve.com     
*!		               Hernan Cortes St., Banilad                       
*!                        Mandaue City, Cebu                           
*!                         6014 Philippines                            
*!Ĵ
*!  tools.prg - are various utilites used by Ng Khai Development Corp  
*!         in developing their program.s  Since these utilities were   
*!         used in the sample program provided, they have been included
*!         as well here together with their source code.               
*!      We trust that you will find these tools useful not only        
*!      in this particular sample program, but any could be adapted    
*!      for use in your many programs.  You are welcome to do so.      
*!  If you should find them useful, or even more so when not           
*!      please feel free to drop us a note or comment.                 
*!  Wilson Ng, EVP, Ng Khai development Corporation                    
*!


*!Ŀ
*!  Procedure Name : UNIQUEF                                  
*!  Author         : Ronald M. Sering                         
*!  Date           : February 23, 1994                        
*!  Function       : Returns a unique filename.               
*!
FUNCTION UNIQUEF

PRIVATE pcTempF

pcTempF = SYS(3)+'.DBF'

DO WHILE FILE(pcTempF)
	pcTempF = SYS(3)+'.DBF'
ENDDO

RETURN pcTempF

* END UNIQUEF
*!Ŀ
*!  Procedure Name : FORCEEXT                                 
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Force the extension of parameter         
*!                   "filname" to be whatever parameter       
*!                   "ext" is.                                
*!  Parameters :                                              
*!                                                            
*!      filname = Name of a file.                             
*!      ext     = Any file extension.                         
*!                                                            
*!
FUNCTION FORCEEXT

PARAMETERS filname,ext

PRIVATE ALL

IF SUBSTR(m.ext,1,1) = "."
   m.ext = SUBSTR(m.ext,2,3)
ENDIF

m.pname = justpath(m.filname)
m.filname = justfname(UPPER(ALLTRIM(m.filname)))
IF AT('.',m.filname) > 0
   m.filname = SUBSTR(m.filname,1,AT('.',m.filname)-1) + '.' + m.ext
ELSE
   m.filname = m.filname + '.' + m.ext
ENDIF
RETURN addbs(m.pname) + m.filname

* END FORCEEXT
*!Ŀ
*!  Procedure Name : DEFAULTEXT                               
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Force the extension of the parameter     
*!                   'filname' to be whatever parameter 'ext' 
*!                   is, unless an extension is already       
*!                   specified.                               
*!                                                            
*!  Parameters :                                              
*!                                                            
*!      filname = Name of the file.                           
*!      ext     = Any extension of a file.                    
*!                                                            
*!
FUNCTION DEFAULTEXT

PARAMETERS filname,ext

PRIVATE ALL

IF EMPTY(justext(m.filname))
   RETURN forceext(m.filname,m.ext)
ELSE
   RETURN m.filname
ENDIF

* END DEFAULTEXT
*!Ŀ
*!  Procedure Name : JUSTFNAME                                
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Returns just the filename (i.e., no path)
*!                   from the parameter 'filname'             
*!                                                            
*!  Parameters :                                              
*!                                                            
*!     filname = Name of any file.                            
*!                                                            
*!
FUNCTION JUSTFNAME

PARAMETERS filname

PRIVATE ALL

IF RAT('\',m.filname) > 0
   m.filname = SUBSTR(m.filname,RAT('\',m.filname)+1,255)
ENDIF
IF AT(':',m.filname) > 0
   m.filname = SUBSTR(m.filname,AT(':',m.filname)+1,255)
ENDIF
RETURN ALLTRIM(UPPER(m.filname))

*END JUSTFNAME
*!Ŀ
*!  Procedure Name : JUSTSTEM                                 
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Returns just the stem name from          
*!                   parameter 'filname'.                     
*!                                                            
*!  Parameters :                                              
*!                                                            
*!     filname = Name of any file.                            
*!                                                            
*!
FUNCTION juststem

PARAMETERS filname

PRIVATE ALL

IF RAT('\',m.filname) > 0
   m.filname = SUBSTR(m.filname,RAT('\',m.filname)+1,255)
ENDIF
IF AT(':',m.filname) > 0
   m.filname = SUBSTR(m.filname,AT(':',m.filname)+1,255)
ENDIF
IF AT('.',m.filname) > 0
   m.filname = SUBSTR(m.filname,1,AT('.',m.filname)-1)
ENDIF
RETURN ALLTRIM(UPPER(m.filname))

*END JUSTSTEM
*!Ŀ
*!  Procedure Name : JUSTEXT                                  
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Returns just the extension from the      
*!                   parameter "filname".                     
*!                                                            
*!  Parameters :                                              
*!                                                            
*!      filname = Name of any file.                           
*!                                                            
*!
FUNCTION JUSTEXT

PARAMETERS filname

PRIVATE ALL
filname = JustFname(m.filname)   && prevents problems with ..\ paths
m.ext = ""
IF AT('.',m.filname) > 0
   m.ext = SUBSTR(m.filname,AT('.',m.filname)+1,3)
ENDIF
RETURN UPPER(m.ext)

*END JUSTEXT
*!Ŀ
*!  Procedure Name : JUSTPATH                                 
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Returns just the path name from the      
*!                   parameter "filname"                      
*!                                                            
*!  Parameters :                                              
*!                                                            
*!     filname = Name of any file.                            
*!                                                            
*!
FUNCTION JUSTPATH

PARAMETERS filname

PRIVATE ALL

m.filname = ALLTRIM(UPPER(m.filname))

IF '\' $ m.filname
   m.filname = SUBSTR(m.filname,1,RAT('\',m.filname))
   IF RIGHT(m.filname,1) = '\' AND LEN(m.filname) > 1 ;
         AND SUBSTR(m.filname,LEN(m.filname)-1,1) <> ':'
      m.filname = SUBSTR(m.filname,1,LEN(m.filname)-1)
   ENDIF
   RETURN m.filname
ELSE
   RETURN ''
ENDIF

* END JUSTPATH
*!Ŀ
*!  Procedure Name : ADDBS                                    
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Add a backslash to a path name, if there 
*!                   isn't already one there.                 
*!                                                            
*!  Parameters :                                              
*!                                                            
*!     pathname = path.                                       
*!                                                            
*!
FUNCTION ADDBS

PARAMETER pathname

PRIVATE ALL
m.pathname = ALLTRIM(UPPER(m.pathname))

IF !(RIGHT(m.pathname,1) $ '\:') AND !EMPTY(m.pathname)
   m.pathname = m.pathname + '\'
ENDIF
RETURN m.pathname

*END ADDBS
*!Ŀ
*!  Procedure Name : DIALOG                                   
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : February 23, 1994                        
*!  Function       : Displays a dialog box.                   
*!                                                            
*!  Parameters :                                              
*!                                                            
*!     strg    = Dialog String                                
*!     cscheme = Color scheme of the dialog window.           
*!     buttons = Push buttons.                                
*!                                                            
*!
FUNCTION DIALOG
PARAMETERS strg, cscheme, buttons   

PRIVATE ALL

SET TALK OFF

in_cons = SET('CONSOLE')

numparams = 4
DIMENSION dflts[numparams,2]
dflts[1,1] = "STRG"
dflts[2,1] = "CSCHEME"
dflts[3,1] = "BUTTONS"
dflts[4,1] = "ACTION"
dflts[1,2] = ''
dflts[2,2] = 7
dflts[3,2] =''
dflts[4,2] = 0

action = 0

FOR i = 1 TO numparams
   IF PARAMETERS() < i
      vname = dflts[i,1]
      &vname = dflts[i,2]
   ENDIF
ENDFOR

m.numlines = OCCURS(';',strg) + 1          && number of message lines
IF !EMPTY(buttons)
   m.numbuts  = OCCURS(';',buttons) + 1    && number of buttons
ELSE
   m.numbuts = 0
ENDIF

DIMENSION alert_arry[numlines]

IF numbuts > 0
   DIMENSION but_arry[numbuts]
ELSE
   DIMENSION but_arry[1]
ENDIF

m.remain = m.strg
m.maxlen = 0
FOR i = 1 TO m.numlines
   IF AT(';',m.remain) > 0
      alert_arry[i] = SUBSTR(m.remain,1,AT(';',m.remain)-1)
      alert_arry[i] = CHRTRAN(alert_arry[i],';','')
      m.remain = SUBSTR(m.remain,AT(';',m.remain)+1)
   ELSE
      alert_arry[i] = m.remain
      m.remain = ''
   ENDIF
   IF LEN(alert_arry[i]) > SCOLS() - 6
      alert_arry[i] = SUBSTR(alert_arry[i],1,SCOLS()-6)
   ENDIF
   IF LEN(alert_arry[i]) > m.maxlen
      m.maxlen = LEN(alert_arry[i])
   ENDIF
ENDFOR

m.remain = m.buttons
m.maxbut = 0
FOR i = 1 TO m.numbuts
   IF AT(';',m.remain) > 0
      but_arry[i] = SUBSTR(m.remain,1,AT(';',m.remain)-1)
      but_arry[i] = CHRTRAN(but_arry[i],';','')
      m.remain = SUBSTR(m.remain,AT(';',m.remain)+1)
   ELSE
      but_arry[i] = m.remain
      m.remain = ''
   ENDIF
   IF LEN(but_arry[i]) > m.maxbut
      m.maxbut = LEN(but_arry[i])
   ENDIF
ENDFOR

IF !EMPTY(buttons)
   m.numlines = m.numlines + 2
ENDIF

m.butsize = m.numbuts * (m.maxbut + 3)    && chevrons + space
IF m.butsize > m.maxlen
   m.maxlen = m.butsize
ENDIF

m.top_row = INT( (SROWS() - 4 - m.numlines) / 2)
m.bot_row = m.top_row + 3 + m.numlines

m.top_col = INT((SCOLS() - m.maxlen - 6) / 2)
m.bot_col = m.top_col + m.maxlen + 6

DEFINE WINDOW alert FROM m.top_row,m.top_col TO m.bot_row,m.bot_col;
   SHADOW COLOR SCHEME (cscheme)
ACTIVATE WINDOW alert

IF !EMPTY(buttons)
   FOR i = 1 TO m.numlines - 2
      @ i,3 SAY PADC(alert_arry[i],m.maxlen)
   ENDFOR
   m.butpos = 3 + (m.maxlen - m.butsize)/2
   @ m.numlines,m.butpos GET action FUNCTION '*HT' PICTURE buttons SIZE 1,m.maxbut+2,1
   READ CYCLE MODAL
ELSE
   FOR i = 1 TO m.numlines
      @ i,3 SAY PADC(alert_arry[i],m.maxlen)
   ENDFOR

   SET CONSOLE OFF
   =INKEY(0,'HM')
   SET CONSOLE ON
ENDIF
RELEASE WINDOW alert

IF in_cons = "OFF"
   SET CONSOLE OFF
ENDIF
RETURN action
*!Ŀ
*!  Procedure Name : _LOCKED                                  
*!  Author         : Ronald M. Sering                         
*!  Date           : February 24, 1994                        
*!  Function       : Locks a record or a file.                
*!                                                            
*!  Parameters :                                              
*!                                                            
*!     pcFile = Name of file to be locked.                    
*!     pcType = "R" - Performs Record locking.                
*!              "F" - Performs File Locking. (Default)        
*!                                                            
*!
FUNCTION _LOCKED

PARAMETERS pcFile, pcType

PRIVATE pcFile, pcType, plLocked

plLocked = .F.

IF EMPTY(pcFile)
	RETURN plLocked
ENDIF

IF EMPTY(pcType)
	pcType = "F"
ELSE
	IF NOT (pcType $ "RF")	
		pcType = "F"
	ENDIF
ENDIF

IF UPPER(pcType) = "F"
	DO WHILE .T.
		IF FLOCK(pcFile)
			plLocked = .T.
			EXIT
		ELSE
			IF DIALOG( JUSTFNAME(pcFile)+" file is in use by another.", 7, "\<Retry ; \<Cancel") = 1
				LOOP
			ELSE
				EXIT
			ENDIF
		ENDIF	
	ENDDO	
ELSE
	DO WHILE .T.
		IF RLOCK(pcFile)
			plLocked = .T.
			EXIT
		ELSE
			IF DIALOG("Current record/file is in use by another.", 7, "\<Retry ; \<Cancel") = 1
				LOOP
			ELSE
				EXIT
			ENDIF
		ENDIF
	ENDDO	
ENDIF	

RETURN plLocked

*END _LOCKED
*!Ŀ
*!  Procedure Name : ACTTHERM                                 
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           :                                          
*!  Function       : Activate thermometer.                    
*!                                                            
*!
PROCEDURE acttherm
PARAMETER m.text

   DEFINE WINDOW thermomete;
      FROM INT((SROW()-6)/2), INT((SCOL()-57)/2) ;
      TO INT((SROW()-6)/2) + 6, INT((SCOL()-57)/2) + 57;
      DOUBLE COLOR SCHEME 5
   ACTIVATE WINDOW thermomete NOSHOW

   @ 0,3 SAY m.text
   @ 2,1 TO 4,54

   SHOW WINDOW thermomete TOP
RETURN
*!Ŀ
*!  Procedure Name : UPDTHERM                                 
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           :                                          
*!  Function       : Update the activated thermometer.        
*!                                                            
*!
PROCEDURE updtherm
PARAMETER m.percent, m.text
PRIVATE m.nblocks, m.percent
PRIVATE m.prompt

m.prompt = IIF(LEN(m.text) > 48,LEFT(m.text,48)+"...",m.text)

ACTIVATE WINDOW thermomete

m.nblocks = (m.percent/100) * (50)
@ 1,3 SAY PADR(m.prompt,54)
@ 3,3 SAY REPLICATE("",m.nblocks)
RETURN
*!Ŀ
*!  Procedure Name : DEACTTHERMO                              
*!  Author         : NK FOXPRO PROGRAMMERS                    
*!  Date           : March 18, 1994                           
*!  Function       : Deactivates thermometer.                 
*!                                                            
*!
PROCEDURE deactthermo
IF WEXIST("thermomete")
   RELEASE WINDOW thermomete
ENDIF
RETURN
*!Ŀ
*!  Procedure Name : COPYFILE                                 
*!  Author         : Ronald M. Sering                         
*!  Date           : March 19, 1994                           
*!  Function       : Copy file to another.                    
*!                                                            
*!  Parameters :                                              
*!                                                            
*!     pcSource = Source file (PATH can be included.)         
*!     pcDest   = Destination file and path.                  
*!                                                            
*!
PROCEDURE COPYFILE
PARAMETER pcSource, pcDest

PRIVATE pcSource				&& Source of the file including its path.
PRIVATE pcDest             && Destination of the file.
PRIVATE pnFHandle          && File handle of the source file.
PRIVATE pnTHandle          && File handle of the destination file.
PRIVATE pnFSize            && File size of the source file.
PRIVATE pcContent				&& Content of source file.
PRIVATE pnFCopied				&& Size copied by the destination file
									&& from the source file.

*
* Open the source file for low-level use and 
* return to the calling program if error is 
* detected otherwise the program continues
*
pnFHandle = FOPEN(pcSource)
IF pnFHandle < 0
	RETURN FERROR()
ENDIF

*
* Open the destination file for low-level use and 
* return to the calling program if error is 
* detected otherwise the program continues
*
pnTHandle = FCREATE(pcDest)
IF pnTHandle < 0
	=FCLOSE(pnFhandle)
	RETURN FERROR()
ENDIF

*
* Get the exact size of the source file
*
pnFSize   = FSEEK(pnFHandle,0,2)

*
* Determine if there is sufficient disk space
* for the operation. If there is, program execution
* continues, otherwise ,it returns to the calling program
*
= FCHSIZE(pnTHandle, pnFSize)
pnFCopied = FSEEK(pnTHandle,0,2)
IF pnFCopied < pnFSize
	=FCLOSE(pnFHandle)
	=FCLOSE(pnTHandle)
	DELETE FILE (pcDest)
	RETURN 29
ENDIF

=FCLOSE(pnFHandle)
=FCLOSE(pnTHandle)

COPY FILE &pcSource TO &pcDest

RELEASE pcSource		
RELEASE pcDest       
RELEASE pnFHandle    
RELEASE pnTHandle    
RELEASE pnFSize      
RELEASE pcContent		
RELEASE pnFCopied		
RETURN 0
*!Ŀ
*!  Procedure Name : RETFERROR                                
*!  Author         : Ronald M. Sering                         
*!  Date           : March 19, 1994                           
*!  Function       : Return error description on last         
*!                   low-level file operation.                
*!  Parameters :                                              
*!                                                            
*!     pnErrNo  = low-level file error no.                    
*!                                                            
*!
FUNCTION RETFERROR
PARAMETER pnErrNo
*begin
	PRIVATE pnErrNo
	DO CASE
		CASE pnErrNo = 2
			RETURN "File not found."
		CASE pnErrNo = 4
			RETURN "Too many files open (out of handles)." 
		CASE pnErrNo = 5
			RETURN "File access denied."
		CASE pnErrNo = 6
			RETURN "Invalid file handle given."
		CASE pnErrNo = 8
			RETURN "Out of memory."
		CASE pnErrNo = 25
			RETURN "Seek error (can't seek before the start of a file)."
		CASE pnErrNo = 29
			RETURN "Insufficient disk space."
		CASE pnErrNo = 31
			RETURN "General failure (EOF encountered)."
		OTHERWISE
			RETURN ""	
	ENDCASE		
*end
*!Ŀ
*!  Procedure Name : DIREXIST                                 
*!  Author         : Ronald M. Sering                         
*!  Date           : March 21, 1994                           
*!  Function       : Return true if directory exist           
*!                   otherwise false.                         
*!  Parameters :                                              
*!                                                            
*!     pcDrvPath = Directory/Path.                            
*!                                                            
*!
FUNCTION DirExist
PARAMETER pcDrvPath

PRIVATE pcDrvPath, pcUniqueF

IF PARAMETERS() = 0
	RETURN
ENDIF

pcUniqueF = UNIQUEF()
pcDrvPath = pcDrvPath + pcUniqueF
FHandle = FCREATE(pcDrvPath)
IF FHandle < 0
	=FCLOSE(FHandle)
	DELETE FILE (pcDrvPath)
	RETURN .F.
ELSE
	=FCLOSE(FHandle)
	DELETE FILE (pcDrvPath)
	RETURN .T.
ENDIF	
